#include <TM1637Display.h>
#include "display.h"
  
int valorfinal;
int button1 = 2;
int button2 = 3;
int button3 = 4;
int button4 = 5;
int buttonAdmin = 6;

int contador1 = 0;
int contador2 = 0;
int contador3 = 0;
int contador4 = 0;
int total = 0;

int buttonState1 = 0;
int buttonState2 = 0;
int buttonState3 = 0;
int buttonState4 = 0;
int buttonStateAdmin = 0;

int pinoBuzzer = 7;

int tempoVotacao = 1000;

const int CLK1 = 8;
const int CLK2 = 9;
const int CLK3 = 10;
const int CLK4 = 11;
const int CLK5 = 13; //total
const int DIO = 12;

TM1637Display display1(CLK1,DIO);
TM1637Display display2(CLK2,DIO);
TM1637Display display3(CLK3,DIO);
TM1637Display display4(CLK4,DIO);
TM1637Display display5(CLK5,DIO);
 
void setup()
{
  Serial.begin(9600); 

  resetDisplay(display1);
  resetDisplay(display2);
  resetDisplay(display3);
  resetDisplay(display4);
  resetDisplay(display5);

  pinMode(button1, INPUT);
  pinMode(button2, INPUT);  
  pinMode(button3, INPUT);  
  pinMode(button4, INPUT);
  pinMode(buttonStateAdmin, INPUT); 

  pinMode(pinoBuzzer,OUTPUT);       
}
 
void loop() 
{ 

  //Botão 1
  buttonState1 = digitalRead(button1);

  // check if the pushbutton is pressed. If it is, the buttonState is HIGH:
  if (buttonState1 == HIGH) {
    digitalWrite(13, HIGH);
    contador1 = contador1 + 1;
    delay(tempoVotacao);
    mostraContador(display1,contador1);
    tocaSom();
  } 

  //Botão 2
  buttonState2 = digitalRead(button2);

  // check if the pushbutton is pressed. If it is, the buttonState is HIGH:
  if (buttonState2 == HIGH) {
    contador2 = contador2 + 1;
    delay(tempoVotacao);
    mostraContador(display2,contador2);
    tocaSom();
  } 

  //Botão 3
  buttonState3 = digitalRead(button3);

  // check if the pushbutton is pressed. If it is, the buttonState is HIGH:
  if (buttonState3 == HIGH) {
    contador3 = contador3 + 1;
    delay(tempoVotacao);
    mostraContador(display3,contador3);    
    tocaSom();
  } 

  //Botão 4
  buttonState4 = digitalRead(button4);

  // check if the pushbutton is pressed. If it is, the buttonState is HIGH:
  if (buttonState4 == HIGH) {
    contador4 = contador4 + 1;
    delay(tempoVotacao);
    mostraContador(display4,contador4);
    tocaSom();
  } 

  //Total
  total = contador1 + contador2 + contador3 + contador4;
  if (total > 0){
    mostraContador(display5,total);    
  }

  //Botão Admin
  buttonStateAdmin = digitalRead(buttonAdmin);

  if (buttonStateAdmin == HIGH) {

    contador1 = 0;
    contador2 = 0;
    contador3 = 0;
    contador4 = 0;

    resetDisplay(display1);
    resetDisplay(display2);
    resetDisplay(display3);
    resetDisplay(display4);
    resetDisplay(display5);
  }   
}

void resetDisplay(TM1637Display &display)
{ 
  display.setBrightness(0xF);
  uint8_t data[] = { 0x0, 0x0, 0x0, 0x0 };
  display.setSegments(data);
}

void mostraContador( TM1637Display &display,int valor)
{
  display.showNumberDec(valor,false);
}

void tocaSom(){
  tone(pinoBuzzer,200);  
  delay(1000); 
  noTone(pinoBuzzer);  
}

//void testeDisplays(){
//
//  //Teste
//  contador1 = 1;
//  contador2 = 2;
//  contador3 = 3;
//  contador4 = 4;
//
//  mostraContador(display1,contador1);
//  mostraContador(display2,contador2);
//  mostraContador(display3,contador3);
//  mostraContador(display4,contador4);
//  mostraContador(display5,total);
//  
//}

